## ros-indigo-cob-kinematics 0.6.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(cob_kinematics)

find_package(catkin REQUIRED COMPONENTS geometry_msgs message_generation moveit_core moveit_msgs pluginlib roscpp std_msgs tf_conversions urdf)

add_service_files(
  FILES
  GetPositionIKExtended.srv
)

generate_messages(
  DEPENDENCIES geometry_msgs moveit_msgs std_msgs
)

catkin_package(
  CATKIN_DEPENDS geometry_msgs message_runtime moveit_msgs std_msgs
)

### BUILD ###
include_directories( ${catkin_INCLUDE_DIRS})

#add_executable(urdf_openrave ros/src/urdf_openrave.cpp)
add_subdirectory(ikfast)

### INSTALL ###

=== ikfast/CMakeLists.txt ===
exec_program("rosversion -d; echo" OUTPUT_VARIABLE ROS_VERSION)

add_custom_target(ikfast_libs DEPENDS urdf_openrave)
include_directories(include)

set(plugins_xml ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/plugins.xml)
file(GLOB yamls "config/*.yaml")
file(WRITE ${plugins_xml} "<class_libraries>\n")

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)
foreach(fname ${yamls})
    GET_FILENAME_COMPONENT(bname ${fname} NAME_WE)
    set(cppout ${CMAKE_CURRENT_SOURCE_DIR}/src/ikfast_${bname}.cpp)
    set(tname ikfast_${bname})

    add_custom_command(
    OUTPUT ${cppout}
    COMMAND python ${EXECUTABLE_OUTPUT_PATH}/genikfast.py ${fname} ${cppout}
    DEPENDS ${fname}
    )

    add_library(${tname} MODULE ${cppout} ../ros/src/ikfast_plugin.cpp)
    set_target_properties(${tname} PROPERTIES COMPILE_DEFINITIONS IKFAST_NAMESPACE=${bname} )
    target_link_libraries(${tname} lapack)

    install(TARGETS ${tname} LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

    file(APPEND ${plugins_xml} "<library path=\"ros/lib/lib${tname}\">\n")
    file(APPEND ${plugins_xml} "<class name=\"cob_kinematics/IKFast_${bname}\" type=\"${bname}::IKFastPlugin\" base_class_type=\"kinematics::KinematicsBase\"/>\n")
    file(APPEND ${plugins_xml} "</library>\n")
endforeach()
file(APPEND ${plugins_xml} "</class_libraries>\n")

install(FILES ${plugins_xml} DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-indigo-cob-kinematics (0.6.6-1trusty) trusty; urgency=high

  * Merge pull request #133 <https://github.com/ipa320/cob_manipulation/issues/133> from ipa320/indigo_release_candidate
    Indigo release candidate
  * Merge pull request #120 <https://github.com/ipa320/cob_manipulation/issues/120> from ipa-fxm/APACHE_license
    use license apache 2.0
  * updated author/maintainer
  * use license apache 2.0
  * Contributors: Felix Messmer, Mathias Lüdtke, ipa-uhr-mk

 -- Felix Messmer <fxm@ipa.fhg.de>  Sat, 06 Jan 2018 23:00:00 -0000

ros-indigo-cob-kinematics (0.6.5-1trusty) trusty; urgency=high

  * Fix ikfast cmake
    * do not write plugins.xml in source space
    * added install tags
  * use xacro --inorder
  * Contributors: Mathias Lüdtke, ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Sun, 30 Jul 2017 22:00:00 -0000

ros-indigo-cob-kinematics (0.6.4-1trusty) trusty; urgency=high



 -- Mathias Luedtke <mdl@ipa.fhg.de>  Thu, 31 Mar 2016 22:00:00 -0000

ros-indigo-cob-kinematics (0.6.3-1trusty) trusty; urgency=high

  * fix dependencies
  * Contributors: ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Sun, 30 Aug 2015 22:00:00 -0000

ros-indigo-cob-kinematics (0.6.2-1trusty) trusty; urgency=high

  * boost revision
  * migration to package format 2
  * remove trailing whitespaces
  * remove obsolete autogenerated mainpage.dox files
  * sort dependencies
  * Contributors: ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Fri, 28 Aug 2015 22:00:00 -0000

ros-indigo-cob-kinematics (0.6.1-1trusty) trusty; urgency=high

  * beautify CMakeLists
  * Contributors: ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Tue, 16 Jun 2015 22:00:00 -0000

ros-indigo-cob-kinematics (0.6.0-1trusty) trusty; urgency=high

  * add catkin_INCLUDE_DIRS to cob_kinematics
  * Merge pull request #43 <https://github.com/ipa320/cob_manipulation/issues/43> from ipa320/hydro_dev
    bringin updates from hydro_dev
  * Merge branch 'hydro_dev' into hydro_release_candidate
  * Merge branch 'hydro_dev' into hydro_release_candidate
  * 0.5.1
  * add changelogs
  * Contributors: Florian Weisshardt, Scott K Logan, ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Wed, 17 Sep 2014 22:00:00 -0000

ros-indigo-cob-kinematics (0.5.2-1trusty) trusty; urgency=high

  * update cob_moveit_config package for all robots
  * Contributors: Felix Messmer

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Wed, 27 Aug 2014 22:00:00 -0000

ros-indigo-cob-kinematics (0.5.1-1trusty) trusty; urgency=high

  * Merge branch 'hydro_dev' into hydro_release_candidate
  * update package maintainer
  * Merge branch 'hydro_dev' into hydro_release_candidate
  * catkin_lint and install tags
  * add changelogs
  * removed a lot of code related to packages not available in hydro anymore
  * added lapack to deps
  * move cob_mmcontroller + groovy_updates
  * fix ikfast + cleanup
  * reduce solver_iterations for faster IK calculation
  * update package.xml
  * catkinize cob_kinematics + use kdl instead of lookat-IK + update moveit_configs
  * update CMakeLists
  * faster lookat_ik solver
  * speedup ik by reducing solver_iterations
  * lookat_ik_plugin
  * NO BUILD of kinematics
  * tweaked harmonization
  * added bound checking to harmonization
  * IK solver based on GT code
  * fixed linker problems
  * added ik10 ikfast plugin
  * added lock_redundant_joints argument to api functions
  * merge with mdl
  * ikfast plugin works now
  * added missing return statement
    fixed return value
  * fixed init
  * merge with ipa-mdl
  * removed outdated components that have moveit substitutes
  * export to moveit_core
  * adapted ikfast_plugin to moveit interface
  * switched to moveit dependencies
  * cob_kinematics: remove everything from CMakeLists that won't build properly (TODOs)
  * ikfast pluging are now included in cob_kinematics again
    Conflicts:
    cob_kinematics/manifest.xml
  * cob_kinematics: fixed plugin path
  * ikfast pluging are now included in cob_kinematics again
  * cob_kinematics: fixed plugin path
  * disabled IKfast plugins
  * added rosdep on liblapack-dev
  * temporarily not using ik-fast plugins - ToBeFixed
  * disabled kinematics_node, must be upated for fuerte
  * Merge remote-tracking branch 'origin-ipa-fxm/fuerte_dev' into fuerte_dev
    Conflicts: (solved)
    cob_manipulator/CMakeLists.txt
    cob_manipulator/manifest.xml
    lwa_arm_navigation/manifest.xml
  * moved kinematics_node from cob_manipulator to cob_kinematics
  * moved KDL plugin overlay from cob_manipulator to cob_kinematics
  * ikfast: debug options
  * ikfast: bug fixes
  * small changes
  * implemented generic searchPositionIK
  * introduced auto-magic IkSolutionListFiltered..
  * added JointSpaceStepper
  * support for consistency limits
  * desired_pose_callback checks
  * implemented getPositionFK
  * added URDF parsing, included IK header/ properties
  * auto-format
  * added license headers
  * lwa solver name fixed
  * fixed ikfast CMake chain
  * simplified electric to fuerte wrapper
  * added missing file
  * little parsing bug fix
  * adapted skeleton to work on electric and fuerte (hopefully)
  * added skeleton for the IKfast solver plugins
  * changed ur5 tip link to arm_wrist_3_link, since arm_ee_link is fixed
  * added configurations and soures for lbr,lwa and ur5
  * added ikfast build pipeline
  * added simple urdf to openrave xml converter
  * cob_ik_wapper now uses robot_state from planning_scene if available
  * prepared ik_wrapper for multiple joint state sources
  * enhanced IK wrapper
  * FK/IK/FK test for solving to tip link at pregrasp
  * fixed names parsing
  * fixed IK handling
  * added IK wrapper
  * new kinematics package
  * Contributors: Florian Weisshardt, Mathias Lüdtke, Witalij Siebert, ipa-fxm

 -- Mathias Luedtke <mdl@ipa.fhg.de>  Tue, 25 Mar 2014 23:00:00 -0000

=== debian/control ===
Source: ros-indigo-cob-kinematics
Section: misc
Priority: extra
Maintainer: Felix Messmer <fxm@ipa.fhg.de>
Build-Depends: debhelper (>= 9.0.0), liblapack-dev, ros-indigo-catkin, ros-indigo-geometry-msgs, ros-indigo-message-generation, ros-indigo-moveit-core, ros-indigo-moveit-msgs, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf-conversions, ros-indigo-urdf
Homepage: http://ros.org/wiki/cob_manipulation/
Standards-Version: 3.9.2

Package: ros-indigo-cob-kinematics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, liblapack-dev, ros-indigo-geometry-msgs, ros-indigo-message-runtime, ros-indigo-moveit-core, ros-indigo-moveit-msgs, ros-indigo-pluginlib, ros-indigo-roscpp, ros-indigo-std-msgs, ros-indigo-tf-conversions, ros-indigo-urdf
Description: IK solvers and utilities for Care-O-bot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-cob-kinematics//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
